/* -*- mode: C -*- */

#include <stdlib.h>
#include <gtk/gtk.h>
#include <cairo-ft.h>
#include <ft2build.h>
#include FT_FREETYPE_H
#include FT_GLYPH_H

//_aa  static gchar police[] = "./n021003l.pfb";  /* Times-Roman */
static gchar police[] = "./s050000l.pfb";     /* Symbol  */


/* "draw" signal need GTK-3  */ 
static gboolean callback_draw (GtkWidget *drawingarea, cairo_t *cr, FT_Face *ft_face)
{

  printf (" num_charmaps = %d \n" ,(*ft_face)->num_charmaps);
  
  if (strncmp (police ,"./s050000l.pfb" ,9) == 0) { 
    if (FT_Select_Charmap (*ft_face ,FT_ENCODING_ADOBE_CUSTOM) != 0) {
      fprintf  (stderr ,"ERROR in FT_Select_Charmap() for ft_face \"Symbol\" ");
    }
  }
  printf ("Char_Index = %d\n" ,FT_Get_Char_Index (*ft_face ,97)); /* 97 is ASCII a */
                         
  cairo_font_face_t *cr_face;
  cr_face  = cairo_ft_font_face_create_for_ft_face (*ft_face ,CAIRO_HINT_METRICS_DEFAULT);
  cairo_set_font_face (cr ,cr_face);
  cairo_set_font_size (cr ,20);
  cairo_move_to   (cr ,50 ,50);
  /* Grace test string  (<128) */
  cairo_show_text (cr ," ! #$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~");
  
  return FALSE;
} 

gint main (gint argc ,gchar *argv[])
{
  GtkWidget *window = NULL;
  GtkWidget *drawingarea = NULL;
  
  /* init gtk */
  gtk_init(&argc ,&argv);

  /* Init FreeType2 */
  FT_Library  library;
  FT_Face     ft_face;
  FT_Error    error = 0;

  error = FT_Init_FreeType( &library );
  if (error) {
    g_printerr ("an error occurred during library initialization\n");
    return EXIT_FAILURE;
  }

  error = FT_New_Face (library ,police ,0 ,&ft_face);
  if ( error == FT_Err_Unknown_File_Format ) {
    g_printerr ("Error %d opening %s.\n" ,error ,police);
    return 1;
  } else if ( error ) {
    g_printerr ("the font file could not be opened or read ,or it is broken\n");
    return 1;
  }
 
  /* create window */
  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_default_size (GTK_WINDOW(window) ,900 ,300);

  drawingarea = gtk_drawing_area_new ();
  gtk_container_add (GTK_CONTAINER (window) ,drawingarea);

  /* Signals */
  g_signal_connect (G_OBJECT(window)       ,"destroy" ,G_CALLBACK (gtk_main_quit)  ,NULL);
  g_signal_connect (G_OBJECT (drawingarea) ,"draw"    ,G_CALLBACK (callback_draw) ,&ft_face);

  /* Show window */
  gtk_widget_show_all (window);

  printf (" Font; %s\n" ,police);
  
  gtk_main ();

  return 0;
}
